//+------------------------------------------------------------------+
//|                                                        ABCTB.mq5 |
//|                                 "Azotskiy Aktiniy ICQ:695710750" |
//|                        "https://login.mql5.com/ru/users/Aktiniy" |
//+------------------------------------------------------------------+
// ABCTB - Auto Build Chart Three Line Break
#property copyright "Azotskiy Aktiniy ICQ:695710750"
#property link      "https://login.mql5.com/ru/users/Aktiniy"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_plots   2
//--- plot ABCTB
#property indicator_label1  "ABCTB"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrBlue,clrRed,clrSilver
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot LINE_TLB
#property indicator_label2  "LINE_TLB"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//---    
enum type_price
  {
   close=0, // Close
   open=1,  // Open
   high=2,  // Hight
   low=3,   // Low
  };
//---  
enum type_build
  {
   classic=0,  // 
   modified=1, // 
  };
//---  
enum priority
  {
   highest_t=4, // 
   high_t=3,    // 
   medium_t=2,  // 
   low_t=1,     // 
  };
//--- input parameters
input long               magic_numb=65758473787389;                //  
input ENUM_TIMEFRAMES    time_frame=PERIOD_CURRENT;                //  
input ENUM_TIMEFRAMES    time_redraw=PERIOD_M1;                    //   
input datetime           first_date_start=D'2013.03.13 00:00:00';  //  
input type_price         chart_price=close;                        //     (0-Close, 1-Open, 2-High, 3-Low)
input int                step_min_f=4;                             //      (>0)
input int                line_to_back_f=3;                         //      (>0)
input type_build         chart_type=classic;                       //   (0-, 1-)
input bool               chart_color_period=true;                  //     
input bool               chart_synchronization=true;               //      
input priority           chart_priority_close=highest_t;           //    
input priority           chart_priority_open=highest_t;            //    
input priority           chart_priority_high=highest_t;            //    
input priority           chart_priority_low=highest_t;             //    
input bool               ma_draw=true;                             //  
input ENUM_APPLIED_PRICE ma_price=PRICE_CLOSE;                     //    
input ENUM_MA_METHOD     ma_method=MODE_EMA;                       //  
input int                ma_period=14;                             //  
//--- indicator buffers
//---  
double         ABCTBBuffer1[];
double         ABCTBBuffer2[];
double         ABCTBBuffer3[];
double         ABCTBBuffer4[];
double         ABCTBColors[];
//---  
double         LINE_TLBBuffer[];
//--- 
MqlRates rates_array[];//       
datetime date_stop;//  
datetime date_start;//   ,  
//+------------------------------------------------------------------+
//| Struct Line Price                                                |
//+------------------------------------------------------------------+
struct line_price//      
  {
   double            up;//   
   double            down;//   
  };
//+------------------------------------------------------------------+
//| Struct Line Information                                          |
//+------------------------------------------------------------------+
struct line_info//        
  {
   double            up;
   double            down;
   char              type;
   datetime          time;
  };
line_info line_main_open[];//      
line_info line_main_high[];//      
line_info line_main_low[];//      
line_info line_main_close[];//      
//+------------------------------------------------------------------+
//| Struct Buffer Info                                               |
//+------------------------------------------------------------------+
struct buffer_info//      
  {
   double            open;
   double            high;
   double            low;
   double            close;
   char              type;
   datetime          time;
  };
buffer_info data_for_buffer[];//      
datetime array_datetime[];//      ,   
int time_array[3];//    func_date_color
datetime time_variable;//    func_date_color
bool latch=false;//     func_date_color
int handle;//   iMA
int step_min;//   
int line_to_back;//     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
//---   
   SetIndexBuffer(0,ABCTBBuffer1,INDICATOR_DATA);
   ArraySetAsSeries(ABCTBBuffer1,true);
   SetIndexBuffer(1,ABCTBBuffer2,INDICATOR_DATA);
   ArraySetAsSeries(ABCTBBuffer2,true);
   SetIndexBuffer(2,ABCTBBuffer3,INDICATOR_DATA);
   ArraySetAsSeries(ABCTBBuffer3,true);
   SetIndexBuffer(3,ABCTBBuffer4,INDICATOR_DATA);
   ArraySetAsSeries(ABCTBBuffer4,true);
   SetIndexBuffer(4,ABCTBColors,INDICATOR_COLOR_INDEX);
   ArraySetAsSeries(ABCTBColors,true);
//---    
   SetIndexBuffer(5,LINE_TLBBuffer,INDICATOR_DATA);
   ArraySetAsSeries(LINE_TLBBuffer,true);
//---      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);//  
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);//  
//---    
   IndicatorSetString(INDICATOR_SHORTNAME,"ABCTB "+IntegerToString(magic_numb)); //  
//---  
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---       
   PlotIndexSetInteger(0,PLOT_SHOW_DATA,false);
   PlotIndexSetInteger(1,PLOT_SHOW_DATA,false);
//---
   handle=iMA(_Symbol,time_frame,ma_period,0,ma_method,ma_price);
   if(step_min_f<1)
     {
      step_min=1;
      Alert("        ");
     }
   else step_min=step_min_f;
//---
   if(line_to_back_f<1)
     {
      line_to_back=1;
      Alert("        ");
     }
   else line_to_back=line_to_back_f;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   if(func_new_bar(time_redraw)==true)
     {
      func_consolidation();
     };
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---     
   if(id==CHARTEVENT_KEYDOWN)
     {
      if(lparam==82) //---    "R"
        {
         func_consolidation();
        }
     }
  }
//+------------------------------------------------------------------+
//| Func Consolidation                                               |
//+------------------------------------------------------------------+
void func_consolidation()
  {
//---   
   date_stop=TimeCurrent();
//---    
   func_all_copy(rates_array,time_frame,first_date_start,date_stop);
//---   
   func_chart_build(chart_price,chart_type);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Func All Copy                                                    |
//+------------------------------------------------------------------+
bool func_all_copy(
                   MqlRates &result_array[],//  
                   ENUM_TIMEFRAMES period,//  
                   datetime data_start,//  
                   datetime data_stop//  
                   )
  {
//---   
   bool x=false;       //    
   int result_copy=-1; //   
//---      
   static MqlRates interim_array[]; //       
   static int bars_to_copy;         //    
   static int bars_copied;          //       
//---       
   bars_to_copy=Bars(_Symbol,period,data_start,data_stop);
//---      
   bars_to_copy-=bars_copied;
//---       
   if(bars_copied>0)
     {
      bars_copied--;
      bars_to_copy++;
     }
//---    
   ArrayResize(interim_array,bars_to_copy);
//---     
   result_copy=CopyRates(_Symbol,period,0,bars_to_copy,interim_array);
//---    
   if(result_copy!=-1) //       
     {
      ArrayCopy(result_array,interim_array,bars_copied,0,WHOLE_ARRAY); //       
      x=true;                   //    
      bars_copied+=result_copy; //    
     }
//---
   return(x);
  }
//+------------------------------------------------------------------+
//| Func Build Three Line Break                                      |
//+------------------------------------------------------------------+
void func_build_three_line_break(
                                 MqlRates &input_array[],//   
                                 char price_type,//    (0-Close, 1-Open, 2-High, 3-Low)
                                 int min_step,//     
                                 int line_back,//    
                                 line_info &line_main_array[]//   () 
                                 )
  {
//---     
   int array_size=ArraySize(input_array);
//---        
   double interim_array[];//  
   ArrayResize(interim_array,array_size);//      
   switch(price_type)
     {
      case 0: // Close
        {
         for(int x=0; x<array_size; x++)
           {
            interim_array[x]=input_array[x].close;
           }
        }
      break;
      case 1: // Open
        {
         for(int x=0; x<array_size; x++)
           {
            interim_array[x]=input_array[x].open;
           }
        }
      break;
      case 2: // High
        {
         for(int x=0; x<array_size; x++)
           {
            interim_array[x]=input_array[x].high;
           }
        }
      break;
      case 3: // Low
        {
         for(int x=0; x<array_size; x++)
           {
            interim_array[x]=input_array[x].low;
           }
        }
      break;
     }
//---        
   line_price passed_line[];//        (  line_price)
   ArrayResize(passed_line,line_back+1);
   int line_calc=0;//  
   int line_up=0;//    
   int line_down=0;//    
   double limit_up=0;//     
   double limit_down=0;//     
/*         */
   passed_line[0].up=interim_array[0];
   passed_line[0].down=interim_array[0];
//---           
   for(int x=0; x<array_size; x++)
     {
      if(line_calc==0)//      
        {
         limit_up=passed_line[0].up;
         limit_down=passed_line[0].down;
         if(interim_array[x]>=limit_up+min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            line_calc++;//   
            line_up++;
           }
         if(interim_array[x]<=limit_down-min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            line_calc++;//   
            line_down++;
           }
        }
      if(line_up>line_down)// () () 
        {
         limit_up=passed_line[0].up;
         limit_down=passed_line[(int)MathMin(line_up,line_back-1)].down;
         if(interim_array[x]>=limit_up+min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            line_calc++;//   
            line_up++;
           }
         if(interim_array[x]<limit_down)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            line_calc++;//   
            line_up=0;
            line_down++;
           }
        }
      if(line_down>line_up)// () () 
        {
         limit_up=passed_line[(int)MathMin(line_down,line_back-1)].up;
         limit_down=passed_line[0].down;
         if(interim_array[x]>limit_up)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            line_calc++;//   
            line_down=0;
            line_up++;
           }
         if(interim_array[x]<=limit_down-min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            line_calc++;//   
            line_down++;
           }
        }
     }
   ArrayResize(line_main_array,line_calc);//    
//---      
   line_calc=0;
   line_up=0;
   line_down=0;
   passed_line[0].up=interim_array[0];
   passed_line[0].down=interim_array[0];
//---       
   for(int x=0; x<array_size; x++)
     {
      if(line_calc==0)//      
        {
         limit_up=passed_line[0].up;
         limit_down=passed_line[0].down;
         if(interim_array[x]>=limit_up+min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            func_insert(line_main_array,passed_line,line_calc,1,input_array[x].time);
            line_calc++;//   
            line_up++;
           }
         if(interim_array[x]<=limit_down-min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            func_insert(line_main_array,passed_line,line_calc,-1,input_array[x].time);
            line_calc++;//   
            line_down++;
           }
        }
      if(line_up>line_down)// () () 
        {
         limit_up=passed_line[0].up;
         limit_down=passed_line[(int)MathMin(line_up,line_back-1)].down;
         if(interim_array[x]>=limit_up+min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            func_insert(line_main_array,passed_line,line_calc,1,input_array[x].time);
            line_calc++;//   
            line_up++;
           }
         if(interim_array[x]<limit_down)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            func_insert(line_main_array,passed_line,line_calc,-1,input_array[x].time);
            line_calc++;//   
            line_up=0;
            line_down++;
           }
        }
      if(line_down>line_up)// () () 
        {
         limit_up=passed_line[(int)MathMin(line_down,line_back-1)].up;
         limit_down=passed_line[0].down;
         if(interim_array[x]>limit_up)//   
           {
            func_regrouping(passed_line,interim_array[x],1);//  
            func_insert(line_main_array,passed_line,line_calc,1,input_array[x].time);
            line_calc++;//   
            line_down=0;
            line_up++;
           }
         if(interim_array[x]<=limit_down-min_step*_Point)//   
           {
            func_regrouping(passed_line,interim_array[x],-1);//  
            func_insert(line_main_array,passed_line,line_calc,-1,input_array[x].time);
            line_calc++;//   
            line_down++;
           }
        }
     }
  }
//+------------------------------------------------------------------+
// Func Regrouping                                                   |
//+------------------------------------------------------------------+
void func_regrouping(
                     line_price &input_array[],//   
                     double new_price,//   
                     char type//  
                     )
  {
   int x=ArraySize(input_array);//   
   for(x--; x>0; x--)//  
     {
      input_array[x].up=input_array[x-1].up;
      input_array[x].down=input_array[x-1].down;
     }
   if(type==1)
     {
      input_array[0].up=new_price;
      input_array[0].down=input_array[1].up;
     }
   if(type==-1)
     {
      input_array[0].down=new_price;
      input_array[0].up=input_array[1].down;
     }
  }
//+------------------------------------------------------------------+
// Func Insert                                                       |
//+------------------------------------------------------------------+
void func_insert(
                 line_info &line_m[],//  
                 line_price &line_i[],//  
                 int index,//   
                 char type,//   
                 datetime time// 
                 )
  {
   line_m[index].up=line_i[0].up;
   line_m[index].down=line_i[0].down;
   line_m[index].type=type;
   line_m[index].time=time;
  }
//+------------------------------------------------------------------+
// Func Chart Build                                                  |
//+------------------------------------------------------------------+
void func_chart_build(
                      char price,//    
                      char type//  
                      )
  {
//---  
   ZeroMemory(ABCTBBuffer1);
   ZeroMemory(ABCTBBuffer2);
   ZeroMemory(ABCTBBuffer3);
   ZeroMemory(ABCTBBuffer4);
   ZeroMemory(ABCTBColors);
   ZeroMemory(LINE_TLBBuffer);
   if(type==1)//    (   )
     {
      func_build_three_line_break(rates_array,0,step_min,line_to_back,line_main_close);//    
      func_build_three_line_break(rates_array,1,step_min,line_to_back,line_main_open);//    
      func_build_three_line_break(rates_array,2,step_min,line_to_back,line_main_high);//    
      func_build_three_line_break(rates_array,3,step_min,line_to_back,line_main_low);//    
      //---   
      int line_main_calc[4];
      line_main_calc[0]=ArraySize(line_main_close);
      line_main_calc[1]=ArraySize(line_main_open);
      line_main_calc[2]=ArraySize(line_main_high);
      line_main_calc[3]=ArraySize(line_main_low);
      //---   
      int all_elements=line_main_calc[0]+line_main_calc[1]+line_main_calc[2]+line_main_calc[3];//    
      datetime datetime_array[];//    
      ArrayResize(datetime_array,all_elements);
      int y[4];
      ZeroMemory(y);
      for(int x=0;x<ArraySize(datetime_array);x++)//    
        {
         if(x<line_main_calc[0])
           {
            datetime_array[x]=line_main_close[y[0]].time;
            y[0]++;
           }
         if(x<line_main_calc[0]+line_main_calc[1] && x>=line_main_calc[0])
           {
            datetime_array[x]=line_main_open[y[1]].time;
            y[1]++;
           }
         if(x<line_main_calc[0]+line_main_calc[1]+line_main_calc[2] && x>=line_main_calc[0]+line_main_calc[1])
           {
            datetime_array[x]=line_main_high[y[2]].time;
            y[2]++;
           }
         if(x>=line_main_calc[0]+line_main_calc[1]+line_main_calc[2])
           {
            datetime_array[x]=line_main_low[y[3]].time;
            y[3]++;
           }
        }
      ArraySort(datetime_array);//  
      //---       
      int good_info=1;
      for(int x=1;x<ArraySize(datetime_array);x++)//    
        {
         if(datetime_array[x-1]!=datetime_array[x])good_info++;
        }
      ArrayResize(array_datetime,good_info);
      array_datetime[0]=datetime_array[0];//    (      )
      good_info=1;
      for(int x=1;x<ArraySize(datetime_array);x++)//     
        {
         if(datetime_array[x-1]!=datetime_array[x])
           {
            array_datetime[good_info]=datetime_array[x];
            good_info++;
           }
        }
      //---    ( )
      int end_of_calc[4];//      
      ZeroMemory(end_of_calc);
      ZeroMemory(data_for_buffer);
      ArrayResize(data_for_buffer,ArraySize(array_datetime));//            
      for(int x=0; x<ArraySize(array_datetime); x++)
        {
         data_for_buffer[x].time=array_datetime[x];
         for(int s=end_of_calc[0]; s<line_main_calc[0]; s++)
           {
            if(array_datetime[x]==line_main_close[s].time)
              {
               end_of_calc[0]=s;
               if(line_main_close[s].type==1)data_for_buffer[x].close=line_main_close[s].up;
               else data_for_buffer[x].close=line_main_close[s].down;
               break;
              }
           }
         for(int s=end_of_calc[1]; s<line_main_calc[1]; s++)
           {
            if(array_datetime[x]==line_main_open[s].time)
              {
               end_of_calc[1]=s;
               if(line_main_open[s].type==1)data_for_buffer[x].open=line_main_open[s].down;
               else data_for_buffer[x].open=line_main_open[s].up;
               break;
              }
           }
         for(int s=end_of_calc[2]; s<line_main_calc[2]; s++)
           {
            if(array_datetime[x]==line_main_high[s].time)
              {
               end_of_calc[2]=s;
               data_for_buffer[x].high=line_main_high[s].up;
               break;
              }
           }
         for(int s=end_of_calc[3]; s<line_main_calc[3]; s++)
           {
            if(array_datetime[x]==line_main_low[s].time)
              {
               end_of_calc[3]=s;
               data_for_buffer[x].low=line_main_low[s].down;
               break;
              }
           }
        }
      //---    
      func_synchronization(data_for_buffer,chart_synchronization,chart_priority_close,chart_priority_open,chart_priority_high,chart_priority_low);
      //---      func_date_color
      ZeroMemory(time_array);
      time_variable=0;
      latch=false;
      //---     
      for(int x=ArraySize(data_for_buffer)-1,z=0; x>=0; x--)
        {
         ABCTBBuffer1[z]=data_for_buffer[x].open;
         ABCTBBuffer2[z]=data_for_buffer[x].high;
         ABCTBBuffer3[z]=data_for_buffer[x].low;
         ABCTBBuffer4[z]=data_for_buffer[x].close;
         if(ABCTBBuffer1[z]<=ABCTBBuffer4[z])ABCTBColors[z]=0;
         if(ABCTBBuffer1[z]>=ABCTBBuffer4[z])ABCTBColors[z]=1;
         if(func_date_color(data_for_buffer[x].time)==true && chart_color_period==true)ABCTBColors[z]=2;
         if(ma_draw==true)LINE_TLBBuffer[z]=func_ma(data_for_buffer[x].time);
         z++;
        }
     }
   else//    (   )
     {
      func_build_three_line_break(rates_array,price,step_min,line_to_back,line_main_close);//     
      ArrayResize(array_datetime,ArraySize(line_main_close));
      //---      func_date_color
      ZeroMemory(time_array);
      time_variable=0;
      latch=false;
      //---     
      for(int x=ArraySize(line_main_close)-1,z=0; x>=0; x--)
        {
         ABCTBBuffer1[z]=line_main_close[x].up;
         ABCTBBuffer2[z]=line_main_close[x].up;
         ABCTBBuffer3[z]=line_main_close[x].down;
         ABCTBBuffer4[z]=line_main_close[x].down;
         if(line_main_close[x].type==1)ABCTBColors[z]=0;
         else ABCTBColors[z]=1;
         if(func_date_color(line_main_close[x].time)==true && chart_color_period==true)ABCTBColors[z]=2;
         if(ma_draw==true)LINE_TLBBuffer[z]=func_ma(line_main_close[x].time);
         z++;
        }
     }
  }
//+------------------------------------------------------------------+
// Func Date Color                                                   |
//+------------------------------------------------------------------+
bool func_date_color(
                     datetime date_time//  
                     )
  {
   bool x=false;//   
   int seconds=PeriodSeconds(time_frame);//   
   MqlDateTime date;
   TimeToStruct(date_time,date);//  
   if(latch==false)//   
     {
      MqlDateTime date_0;
      date_0=date;
      date_0.hour=0;
      date_0.min=0;
      date_0.sec=0;
      int difference=date_0.day_of_week-1;
      datetime date_d=StructToTime(date_0);
      date_d=date_d-86400*difference;
      time_variable=date_d;
      latch=true;//  
     }
   if(seconds<=7200)//     H2
     {
      if(time_array[0]!=date.day)
        {
         x=true;
         time_array[0]=date.day;
        }
     }
   if(seconds>7200 && seconds<=43200)//   H2     H12
     {
      if(time_variable>=date_time)
        {
         x=true;
         time_variable=time_variable-604800;
        }
     }
   if(seconds>43200 && seconds<=86400)//   H12     D1
     {
      if(time_array[1]!=date.mon)
        {
         x=true;
         time_array[1]=date.mon;
        }
     }
   if(seconds>86400)//  W1  MN
     {
      if(time_array[2]!=date.year)
        {
         x=true;
         time_array[2]=date.year;
        }
     }
   return(x);
  }
//+------------------------------------------------------------------+
// Func Synchronization                                              |
//+------------------------------------------------------------------+
void func_synchronization(
                          buffer_info &info[],
                          bool synchronization,
                          char close,
                          char open,
                          char high,
                          char low
                          )
  {
   if(synchronization==true)//   
     {
      int calc=0;//  
      for(int x=0; x<ArraySize(info); x++)//    
        {
         if(info[x].close!=0 && info[x].high!=0 && info[x].low!=0 && info[x].open!=0)calc++;
        }
      buffer_info i_info[];//     
      ArrayResize(i_info,calc);//    
      calc=0;
      for(int x=0; x<ArraySize(info); x++)//     
        {
         if(info[x].close!=0 && info[x].high!=0 && info[x].low!=0 && info[x].open!=0)
           {
            i_info[calc]=info[x];
            calc++;
           }
        }
      ZeroMemory(info);//   
      ArrayResize(info,calc);//    
      for(int x=0; x<calc; x++)//       
        {
         info[x]=i_info[x];
        }
     }
   if(synchronization==false)//     
     {
      int size=ArraySize(info);//   
      double buffer[][4];//     
      ArrayResize(buffer,size);//    
      for(int x=0; x<size; x++)//     
        {
         buffer[x][0]=info[x].close;
         buffer[x][1]=info[x].open;
         buffer[x][2]=info[x].high;
         buffer[x][3]=info[x].low;
        }
      char p[4];//      
      p[0]=close; p[1]=open; p[2]=high; p[3]=low;//     
      ArraySort(p);// 
      int z=0,v=0;//    
      for(int x=0; x<4; x++)//         
        {
         if(p[x]==close)//    
           {
            for(z=0; z<size; z++)
              {
               for(v=1; v<4; v++)
                 {
                  if(buffer[z][v]==0)buffer[z][v]=buffer[z][0];
                 }
              }
           }
         if(p[x]==open)//    
           {
            for(z=0; z<size; z++)
              {
               for(v=0; v<4; v++)
                 {
                  if(v!=1 && buffer[z][v]==0)buffer[z][v]=buffer[z][1];
                 }
              }
           }
         if(p[x]==high)//    
           {
            for(z=0; z<size; z++)
              {
               for(v=0; v<4; v++)
                 {
                  if(v!=2 && buffer[z][v]==0)buffer[z][v]=buffer[z][2];
                 }
              }
           }
         if(p[x]==low)//    
           {
            for(z=0; z<size; z++)
              {
               for(v=0; v<3; v++)
                 {
                  if(buffer[z][v]==0)buffer[z][v]=buffer[z][3];
                 }
              }
           }
        }
      for(int x=0; x<size; x++)//      
        {
         info[x].close=buffer[x][0];
         info[x].open=buffer[x][1];
         info[x].high=buffer[x][2];
         info[x].low=buffer[x][3];
        }
     }
  }
//+------------------------------------------------------------------+
// Func MA                                                           |
//+------------------------------------------------------------------+
double func_ma(
               datetime date
               )
  {
   double x[1];
   CopyBuffer(handle,0,date,1,x);
   return(x[0]);
  }
//+------------------------------------------------------------------+
//| Func New Bar                                                     |
//+------------------------------------------------------------------+
bool func_new_bar(ENUM_TIMEFRAMES period_time)
  {
//---
   static datetime old_times; //    
   bool res=false;            //     
   datetime new_time[1];      //   
//---
   int copied=CopyTime(_Symbol,period_time,0,1,new_time); //       new_time  
//---
   if(copied>0) //  .  
     {
      if(old_times!=new_time[0]) //       
        {
         if(old_times!=0) res=true; //     ,   =  
         old_times=new_time[0];     //   
        }
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
